      SUBROUTINE  IMPLIC
C
C     PROCESS IMPLICIT STATEMENT WITH THE SYNTAX
C
C     IMPLICIT TYPE1*S1(RANGE1),TYPE2*S2(RANGE2),...
C
C     WHERE TYPEK IS ONE OF THE 5 STANDARD FORTRAN TYPE KEYWORDS,
C     SK IS AN OPTIONAL LENGTH MODIFIER, AND RANGEK TAKES THE FORM
C     OF A LIST OF ALPHABETIC LETTERS SEPARATED BY COMMAS, OR
C     LETTER PAIRS SEPARATED BY A MINUS SIGN, INDICATING A RANGE
C     OF LETTERS.  ON ENTRY, PSTMT IS ASSUMED TO BE POINTING AT
C     THE KEYWORD FOLLOWING 'IMPLICIT'.
C
C     IN ADDITION TO RECORDING THE SPECIFIED TYPES IN THE TYPE
C     CODE TABLE, LETTYP(*) IN COMMON /TYPCOD/, THE ROUTINE NAME
C     AND ARGUMENTS MUST BE LOCATED AND THEIR TYPES SET
C     APPROPRIATELY.
C
      INTEGER STMT, PSTMT, CLASS, COUNT, TMPTYP(28), TYPVAR, PDSA, DSA,
     X     STACK
      LOGICAL LETTER, TOKLMO, ERR, SYSERR, ABORT
      COMMON /CEXPRS/  LSTACK,      STACK(620)
      COMMON /CTABL /  LDSA,        PDSA,        DSA(5000)
      COMMON /FACTS /  NAME,        NOST,        ITYP,        IASF
      COMMON /LETDEF/  LET0,        LET1,        LET2,        LET3
      COMMON /LETDEF/  LET4,        LET5,        LET6,        LET7
      COMMON /LETDEF/  LET8,        LET9,        LETA,        LETB
      COMMON /LETDEF/  LETC,        LETD,        LETE,        LETF
      COMMON /LETDEF/  LETG,        LETH,        LETI,        LETJ
      COMMON /LETDEF/  LETK,        LETL,        LETM,        LETN
      COMMON /LETDEF/  LETO,        LETP,        LETQ,        LETR
      COMMON /LETDEF/  LETS,        LETT,        LETU,        LETV
      COMMON /LETDEF/  LETW,        LETX,        LETY,        LETZ
      COMMON /LETDEF/  LETDOL,      LETUSC,      LETPLS,      LETMNS
      COMMON /LETDEF/  LETRP,       LETEQ,       LETDOT,      LETLP
      COMMON /LETDEF/  LETAST,      LETSLS,      LETCMA,      LETBLK
      COMMON /LETDEF/  LETSQT
      COMMON /INPUT/   NSTMT,       PSTMT,       STMT(1327)
      COMMON /DETECT/  ERR,         SYSERR,      ABORT
      COMMON /TYPCOD/  LETTYP(28)
C
      LETTER(IARG) = ((LETA .LE. IARG) .AND. (IARG .LE. LETUSC))
C
C     ISSUE A WARNING MESSAGE THAT THE IMPLICIT STATEMENT IS NOT
C     PORTABLE, BUT DO NOT SET THE ERROR FLAG.
C
      CALL ERROR1 (35H IMPLICIT STATEMENT IS NOT PORTABLE,35)
C
C     SAVE THE CURRENT LETTER TYPE DEFINITIONS.  THESE WILL BE
C     REPLACED IF PROCESSING IS SUCCESSFUL HERE.
C
      DO 10 I = 1,28
           TMPTYP(I) = LETTYP(I)
   10 CONTINUE
C
C     GET THE NEXT TYPE KEYWORD.
C
   20 CALL TYPST (JTYP,CLASS,COUNT)
      IF (JTYP .GT. 5) GO TO 120
      PSTMT = PSTMT + COUNT
      IF (.NOT.TOKLMO(PSTMT,K2,LL)) GO TO 30
C
C     TOKEN WAS A LENGTH MODIFIER.  ISSUE A WARNING MESSAGE, BUT
C     DO NOT SET ERROR FLAG, SINCE WE WILL JUST IGNORE THE
C     MODIFIER.
C
      PSTMT = K2
      CALL ERROR1 (
     X62H TYPE STATEMENT LENGTH MODIFIER IS ILLEGAL -- MODIFIER IGNORED,
     X62)
C
C     IF 'REAL*8' WAS SPECIFIED, ASSUME DOUBLE PRECISION AND ISSUE
C     A WARNING MESSAGE.
C
      IF (.NOT.( (JTYP .EQ. 2) .AND. (LL .EQ. 8) )) GO TO 30
      CALL ERROR1 (40H REAL*8 ASSUMED TO MEAN DOUBLE PRECISION,40)
      JTYP = 1
C
C     DECODE THE RANGE SPECIFICATION.
C
   30 IF (STMT(PSTMT) .NE. LETLP) GO TO 130
      PSTMT = PSTMT + 1
   40 IF (.NOT.LETTER(STMT(PSTMT))) GO TO 130
      IF (STMT(PSTMT) .EQ. LETDOL) CALL ERROR1 (
     X58H DOLLAR SIGN IS NOT PART OF PORTABLE FORTRAN CHARACTER SET,58)
      IF (STMT(PSTMT) .EQ. LETUSC) CALL ERROR1 (
     X57H UNDERSCORE IS NOT PART OF PORTABLE FORTRAN CHARACTER SET,57)
      L1 = STMT(PSTMT)
      L2 = L1
      IF (STMT(PSTMT+1) .EQ. LETCMA) GO TO 50
      IF (STMT(PSTMT+1) .EQ. LETRP ) GO TO 60
      IF (STMT(PSTMT+1) .NE. LETMNS) GO TO 130
      PSTMT = PSTMT + 2
      IF (.NOT.LETTER(STMT(PSTMT))) GO TO 130
      IF (STMT(PSTMT) .EQ. LETDOL) CALL ERROR1 (
     X58H DOLLAR SIGN IS NOT PART OF PORTABLE FORTRAN CHARACTER SET,58)
      IF (STMT(PSTMT) .EQ. LETUSC) CALL ERROR1 (
     X57H UNDERSCORE IS NOT PART OF PORTABLE FORTRAN CHARACTER SET,57)
      L2 = STMT(PSTMT)
   50 IF (L2 .GE. L1) GO TO 60
      L2SWAP = L2
      L2 = L1
      L1 = L2SWAP
   60 DO 70 I = L1,L2
           K = I - LETA + 1
           TMPTYP(K) = JTYP
   70 CONTINUE
      IF (STMT(PSTMT+1) .EQ. LETRP) GO TO 80
      IF (STMT(PSTMT+1) .NE. LETCMA) GO TO 130
      PSTMT = PSTMT + 2
      GO TO 40
C
C     RIGHT PARENTHESIS HAS BEEN REACHED.  IF NOT AT END OF STATEMENT
C     AND COMMA FOLLOWS, LOOP BACK FOR NEXT KEYWORD.
C
   80 IF ((PSTMT+2) .EQ. NSTMT) GO TO 90
      IF (STMT(PSTMT+2) .NE. LETCMA) GO TO 130
      PSTMT = PSTMT + 3
      GO TO 20
C
C     END OF STATEMENT REACHED SUCCESSFULLY.  RESET TYPE FLAGS
C     IN COMMON.
C
   90 DO 100 I = 1,28
           LETTYP(I) = TMPTYP(I)
  100 CONTINUE
C
C     NOW LOCATE THE ROUTINE NAME AND ARGUMENT NAMES AND RESET
C     THEIR TYPES ACCORDING TO THE TYPE CODE TABLE.
C
      NEXT = DSA(NAME+2)
      IF (IGATT1(NAME, 8) .NE. 4) GO TO 110
C
C     PROGRAM UNIT IS A FUNCTION.  UNPACK ITS NAME, DETERMINE ITS
C     TYPE, CLEAR THE TYPE FIELD, AND RESET IT AS IMPLICITLY
C     TYPED.
C
      CALL S5UNPK (DSA(NAME+4), STACK(1), 1)
      CALL SATT1 (NAME, 1, 0)
      CALL SATT1 (NAME, 1, TYPVAR(MAPCHR(STACK(1),ERR)))
C
C     NOW SCAN THE ARGUMENT LIST, EXTRACTING THE NAMES AND
C     IMPLICITLY RETYPING THEM.
C
  110 IF (NEXT .LE. 0) GO TO 140
      K = DSA(NEXT)
      CALL S5UNPK (DSA(K+4), STACK(1), 1)
      CALL SATT1 (K, 1, 0)
      CALL SATT1 (K, 1, TYPVAR(MAPCHR(STACK(1),ERR)))
      NEXT = DSA(NEXT+1)
      GO TO 110
C
C     ERROR MESSAGES AND RETURN SECTION
C
  120 CALL ERROR1 (21H ILLEGAL TYPE KEYWORD,21)
      ERR = .TRUE.
      GO TO 140
  130 CALL ERROR1 (20H ILLEGAL PUNCTUATION,20)
      ERR = .TRUE.
  140 RETURN
      END
