C     (MAIN - Unix VERSION)
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C                            PFORT VERIFIER
C
C                              B. G. RYDER
C                              A. D. HALL
C
C           BELL LABORATORIES, MURRAY HILL, NEW JERSEY 07974
C
C
C       COPYRIGHT C 1978,  BELL  TELEPHONE  LABORATORIES,  INCOR-
C       PORATED.   GENERAL  PERMISSION  IS  GRANTED  TO  MAKE AND
C       DISTRIBUTE UNMODIFIED COMPLETE COPIES  OF  THIS  COMPUTER
C       PROGRAM, BUT NOT FOR PROFIT, PROVIDED THAT THIS COPYRIGHT
C       NOTICE AND STATEMENT ARE INCLUDED.
C
C
C                    EXTENDED PFORT VERIFIER
C 
C                       NELSON H.F. BEEBE
C             DEPARTMENTS OF PHYSICS AND CHEMISTRY
C                      UNIVERSITY OF UTAH
C                   SALT LAKE CITY, UT 84112
C                      TEL: (801) 581-5254
C
C     THE MODIFICATIONS TO THE ORIGINAL PFORT VERIFIER TO PRODUCE
C     THE  "EXTENDED   PFORT   VERIFIER"  ARE   MADE   WITH   THE
C     AUTHORIZATION OF BELL  LABORATORIES.  THE COPYRIGHT  NOTICE
C     GIVEN ABOVE APPLIES AS WELL TO THE EXTENDED PFORT  VERIFIER
C     AND  BELONGS   TO   BELL   LABORATORIES.    HOWEVER,   BELL
C     LABORATORIES PROVIDES  NO SUPPORT  FOR THE  EXTENDED  PFORT
C     VERIFIER,  AND  ANY  CORRESPONDENCE  REGARDING  IT   SHOULD
C     THEREFORE BE DIRECTED TO N.H.F.  BEEBE IN UTAH.
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C-----------------------------------------------------------------------
C
C     NEW MAIN PROGRAM FOR THE PFORT VERIFIER.  THIS ROUTINE DEFINES
C     THE NUMBER OF CHARACTERS/WORD ON THE HOST MACHINE, AS WELL AS
C     ALL THE FILES REQUIRED BY THE PFORT VERIFIER.
C
C     IT MAY BE NECESSARY ON SOME MACHINES TO PROVIDE DEFINITIONS OF
C     ALL COMMON BLOCKS IN THIS ROUTINE.
C     (10-OCT-84)
      INTEGER          NCHPWD,      NDCL,        NOPT
      INTEGER          NFOR,        NPFL
      CHARACTER*144    CMDARG,      FLNAME
      INTEGER          IARGC,       IOS,         NARGS,       CHRTRM
C
      DATA             NFOR    / 1 /
      DATA             NPFL    / 2 /
C-----------------------------------------------------------------------
C
C     Define the number of characters per integer word on the host.
C
      NCHPWD = 4
C
C     Get the file name(s) from the command line.  Each file name
C     results  in one invocation of the Extended PFORT  Verifier.
C     Any extension ".f" is discarded to obtain  the  root  name,
C     and then extensions ".f", ".pfl", and ".dcl" are attached.
C
      NARGS = IARGC()
      IF (NARGS .LT. 1) THEN
           WRITE (0,'('' Usage: pfort [-o -o ... -o] filelist'')')
           STOP
      END IF
C
C     Open the scratch files outside the main loop.
C
      OPEN (UNIT=12,STATUS='scratch',FORM='unformatted')
      OPEN (UNIT=13,STATUS='scratch',FORM='unformatted')
      OPEN (UNIT=14,STATUS='scratch',FORM='unformatted')
      NFILES = 0
      DO 10 M = 1,NARGS
      CALL GETARG (M,CMDARG)
      L = CHRTRM(CMDARG)
      IF (CMDARG(1:1) .EQ. '-') GO TO 10
      NFILES = NFILES + 1
C
C     For  the time being, process only one argument.   Following
C     ones are not handled correctly,  perhaps  due  to  variable
C     initialization problems.
C
      IF (NFILES .GT. 1) GO TO 10
      IF (L .GT. 2) THEN
           IF (CMDARG(L-1:L) .EQ. '.f') L = L - 2
      END IF
C
C     Open the source, listing, and declaration files.
C
      FLNAME = CMDARG(1:L)//'.f'
      OPEN (UNIT=NFOR,FILE=FLNAME,STATUS='old',FORM='formatted',
     X     IOSTAT=IOS)
      IF (IOS .NE. 0) THEN
           WRITE (0,'('' ?Cannot open '',A)') FLNAME
           GO TO 10
      END IF
      FLNAME = CMDARG(1:L)//'.pfl'
      OPEN (UNIT=NPFL,FILE=FLNAME,STATUS='new',FORM='formatted')
C
C     Define the default option file.  If "filename.opt" does not
C     exist, try "pfort.opt" and "$HOME/pfort.opt".
C
      NOPT = 15
      FLNAME = CMDARG(1:L)//'.opt'
      OPEN (UNIT=NOPT,FILE=FLNAME,STATUS='old',FORM='formatted',
     X     IOSTAT=IOS)
      IF (IOS .NE. 0) THEN
           FLNAME = 'pfort.opt'
           OPEN (UNIT=NOPT,FILE=FLNAME,STATUS='old',FORM='formatted',
     X          IOSTAT=IOS)           
      END IF
      IF (IOS .NE. 0) THEN
           FLNAME = '$HOME/pfort.opt'
           OPEN (UNIT=NOPT,FILE=FLNAME,STATUS='old',FORM='formatted',
     X          IOSTAT=IOS)           
      END IF
      IF (IOS .NE. 0) NOPT = 0
C
C     Define the declaration output file.
C
      NDCL = 16
      FLNAME = CMDARG(1:L)//'.dcl'
      OPEN (UNIT=NDCL,FILE=FLNAME,STATUS='new',FORM='formatted',
     X     IOSTAT=IOS)
      REWIND NFOR
      REWIND NPFL
      REWIND 12
      REWIND 13
      REWIND 14
      IF (NOPT .NE. 0) REWIND NOPT
      REWIND NDCL
      CALL PFORT  (NCHPWD, NFOR,NPFL,12,13,14,NOPT,NDCL)
      REWIND NFOR
      REWIND NPFL
      IF (NOPT .NE. 0) REWIND NOPT
      REWIND NDCL
      CLOSE (UNIT=NFOR)
      CLOSE (UNIT=NPFL)
      IF (NOPT .NE. 0) CLOSE (UNIT=NOPT)
      CLOSE (UNIT=NDCL)
   10 CONTINUE
      REWIND 12
      REWIND 13
      REWIND 14
      CLOSE (UNIT=12)
      CLOSE (UNIT=13)
      CLOSE (UNIT=14)
      END
