      SUBROUTINE  OUTTOK (DSAIDX,TAB,OUTDIM,CONTIN,DUMP,LSTPOS)
C
C     OUTPUT A TOKEN STORED AT ENTRY 'DSAIDX' IN DSA(*) IN COMMON TO
C     THE LINE BUFFER IN STACK(*).
C
C     IF 'TAB' IS .TRUE., THE TOKEN WILL BE POSITIONED AT THE NEXT
C     TAB POSITION.  OTHERWISE, IT IS POSITIONED FOLLOWING THE NEXT
C     BLANK IN THE LINE.
C
C     IF 'OUTDIM' IS .TRUE., ANY DIMENSIONS OF THE TOKEN WILL ALSO
C     BE OUTPUT.
C
C     IF 'CONTIN' IS .TRUE., A CONTINUATION LINE IS GENERATED AFTER
C     THE FIRST LINE IS OUTPUT.  THE CONTINUATION LINE WILL HAVE A
C     COMMA IN COLUMN 7, SINCE IT IS NOT POSSIBLE TO KNOW WHEN THE
C     PREVIOUS LINE IS OUTPUT WHETHER OR NOT FURTHER ITEMS REMAIN TO
C     BE OUTPUT.  IF 'CONTIN' IS .FALSE., THE CONTENTS OF THE LINE
C     UP TO TABCOL(2)-1 ARE LEFT INTACT.  'CONTIN' IS IGNORED IF
C     'DUMP' IS .TRUE.
C
C     IF 'DUMP' IS .TRUE., THE OTHER ARGUMENTS ARE IGNORED AND THE
C     CURRENT CONTENTS OF STACK(*) ARE OUTPUT TO THE DECLARATION
C     FILE, AND 'LSTPOS' IS RESET TO 0.
C
C     ON ENTRY, 'LSTPOS' IS THE INDEX OF THE LAST POSITION USED IN
C     STACK(*), AND IS UPDATED ACCORDINGLY ON RETURN.
C     STACK(LSTPOS+1) WILL CONTAIN A COMMA IF WE ARE IN THE
C     VARIABLE LIST FIELD, SO THAT THE CURRENT TOKEN WILL BE
C     PROPERLY SEPARATED FROM THE NEXT ONE.
C
C     THE SPECIAL CASE OF A BLANK COMMON NAME STORED AS "*COM" IS
C     CHECKED FOR AND A BLANK NAME IS OUTPUT INSTEAD.
C
      LOGICAL TAB, OUTDIM, CONTIN, DUMP, NEEDCM
      INTEGER DSAIDX, LSTPOS, TABCOL(6), BLANK, COMMA, I, K, CONTCH,
     X     INIPOS, START, ITAB, INFO, IGATT1, LPAREN, RPAREN, NDIMS,
     X     STAR
C
      INTEGER LDSA, PDSA, DSA
      COMMON /CTABL/ LDSA, PDSA, DSA(5000)
C
      INTEGER LSTACK, STACK
      COMMON /CEXPRS/ LSTACK, STACK(620)
C
      INTEGER DCLFIL
      LOGICAL DCLOUT
      COMMON /DCLCB/ DCLFIL,DCLOUT
C
C     TAB POSITIONS (ALSO DEFINED IN ROUTINE 'OUTTYP').  TABCOL(1)
C     IS THE COLUMN IN WHICH A COMMON NAME STARTS.  TABCOL(2)...
C     ARE THE COLUMNS AT WHICH VARIABLES IN THE LISTS BEGIN.
C     TABCOL(1) AND TABCOL(2) MUST ALWAYS BE DEFINED.
C     TABCOL(MAXTAB) (MAXTAB .GE. 3) MUST BE A VALUE AT LEAST AS
C     LARGE AS THE OUTPUT LINE LENGTH + SIZE OF LARGEST TOKEN
C     (INCLUDING ITS DIMENSIONS) + 2 (TRAILING BLANK AND COMMA).
C
      DATA TABCOL(1), TABCOL(2), TABCOL(3), TABCOL(4), TABCOL(5),
     X     TABCOL(6) /16, 27, 40, 53, 66, 9999/
      DATA MAXTAB/6/
      DATA BLANK /1H /, COMMA/1H,/, LPAREN/1H(/, RPAREN/1H)/
      DATA CONTCH/1HX/, STAR/1H*/
      IF (.NOT.DUMP) GO TO 10
      IF (LSTPOS .GE. TABCOL(2)) WRITE (DCLFIL,99999) (STACK(I),I = 1,
     X     LSTPOS)
      LSTPOS = 0
      GO TO 220
   10 INIPOS = LSTPOS
      START = LSTPOS + 1
      IF (TAB) GO TO 40
C
C     NO TABBING - POSITION TO NEXT BLANK IF WE ARE IN THE VARIABLE
C                  FIELD.
C
      IF (LSTPOS .LT. TABCOL(2)) GO TO 70
   20 IF (STACK(LSTPOS) .EQ. BLANK) GO TO 30
      LSTPOS = LSTPOS + 1
      GO TO 20
   30 START = LSTPOS + 1
      GO TO 70
C
C     TABBING - POSITION TO THE NEXT TAB STOP.
C
   40 ITAB = 1
      IF (STACK(LSTPOS+1) .EQ. COMMA) LSTPOS = LSTPOS + 1
   50 IF ((LSTPOS .LT. TABCOL(ITAB)) .OR. (ITAB .GE. MAXTAB)) GO TO 60
      ITAB = ITAB + 1
      GO TO 50
   60 START = TABCOL(ITAB)
C
C     IF THE LINE IS ALREADY FILLED UP PAST THE LAST TAB POSITION,
C     OUTPUT IT AND RESET TO THE SECOND TAB POSITION WHERE THE
C     VARIABLE LIST STARTS.
C
   70 IF (START .LE. TABCOL(MAXTAB-1)) GO TO 110
      IF (.NOT.CONTIN) GO TO 80
      NEEDCM = (INIPOS .GE. 72)
      IF (.NOT.NEEDCM) INIPOS = INIPOS + 1
   80 WRITE (DCLFIL,99999) (STACK(I), I = 1,INIPOS)
      START = TABCOL(2)
           DO 90 I = START,73
           STACK(I) = BLANK
   90      CONTINUE
      IF (.NOT.CONTIN) GO TO 110
           DO 100 I = 1,START
           STACK(I) = BLANK
  100      CONTINUE
      STACK(6) = CONTCH
      IF (NEEDCM) STACK(7) = COMMA
C
C     OUTPUT THE TOKEN, THEN POSITION TO THE FIRST BLANK FOLLOWING
C     IT.  THE SPECIAL CASE OF BLANK COMMON STORED AS THE NAME
C     '*COM' IS CHECKED FOR.
C
  110 CALL S5UNPK (DSA(DSAIDX+4),STACK(START),6)
      LSTPOS = START
      IF (STACK(LSTPOS) .NE. STAR) GO TO 120
      STACK(LSTPOS  ) = BLANK
      STACK(LSTPOS+1) = BLANK
      STACK(LSTPOS+2) = BLANK
      STACK(LSTPOS+3) = BLANK
      STACK(LSTPOS+4) = BLANK
      STACK(LSTPOS+5) = BLANK
  120 IF (STACK(LSTPOS+1) .EQ. BLANK) GO TO 130
      LSTPOS = LSTPOS + 1
      GO TO 120
C
C     OUTPUT ARRAY DIMENSIONS IF REQUESTED.
C
  130 IF (.NOT.OUTDIM) GO TO 170
      NDIMS = IGATT1(DSAIDX,7)
      IF (NDIMS .LE. 0) GO TO 170
      INFO = DSA(DSAIDX+2)
      STACK(LSTPOS+1) = LPAREN
      LSTPOS = LSTPOS + 1
           DO 160 I = 1,NDIMS
           K = DSA(INFO+2)
           INFO = INFO + 1
           CALL S5UNPK (DSA(K+4),STACK(LSTPOS+1),6)
           STACK(LSTPOS+7) = BLANK
  140      IF (STACK(LSTPOS+1) .EQ. BLANK) GO TO 150
           LSTPOS = LSTPOS + 1
           GO TO 140
  150      LSTPOS = LSTPOS + 1
           STACK(LSTPOS) = COMMA
  160      CONTINUE
      STACK(LSTPOS) = RPAREN
C
C     INSERT A COMMA AFTER THE LAST CHARACTER, UNLESS WE ARE
C     NOT PAST THE SECOND TAB POSITION (WHICH MARKS THE START
C     OF THE VARIABLE LIST FIELD).
C
  170 IF (LSTPOS .GE. TABCOL(2)) STACK(LSTPOS+1) = COMMA
C
C     IF WE HAVE INSUFFICIENT SPACE FOR THE TOKEN, OUTPUT THE
C     CURRENT LINE AND RESET TO THE SECOND TAB POSITION,
C     THEN MOVE THE TOKEN BACK TO THAT POSITION.  BECAUSE
C     TOKENS ARE LIMITED IN LENGTH TO 6 CHARACTERS, THE
C     LONGEST TOKEN UNIT CAN BE NO MORE THAN 6 + 1 + 6 + 1 +
C     6 + 1 + 6 + 1 = 28 CHARACTERS (3-DIMENSIONAL ARRAY),
C     WHICH IS GUARANTEED TO FIT SINCE (TABCOL(2) + 27) .LE.
C     72.
C
      IF (LSTPOS .LE. 72) GO TO 220
      IF (CONTIN) INIPOS = INIPOS + 1
      WRITE (DCLFIL,99999) (STACK(I), I = 1,INIPOS)
      INIPOS = TABCOL(2) - 1
      IF (.NOT.CONTIN) GO TO 190
           DO 180 I = 1,INIPOS
           STACK(I) = BLANK
  180      CONTINUE
      STACK(6) = CONTCH
  190      DO 200 I = START,LSTPOS
           INIPOS = INIPOS + 1
           STACK(INIPOS) = STACK(I)
  200      CONTINUE
      LSTPOS = INIPOS
           DO 210 I = LSTPOS,72
           STACK(I+1) = BLANK
  210      CONTINUE
      STACK(LSTPOS+1) = COMMA
  220 RETURN
C
99999 FORMAT (72A1)
      END
